unit Mouse;
interface
var   MousePresent:Boolean;

function MouseInit(var nb:Integer):Boolean;
procedure MouseShow;
procedure MouseHide;
procedure MouseRead(var X,Y,bMask:integer);
procedure MouseSetPos(x,y:Word);
function MouseGetb(bMask:Word;var Count,LastX,LastY:Word):Word;
procedure MouseKeyPreset(var Key,Sost,X,Y:integer);
procedure MouseMinXMaxX(MinX,MaxX:Integer);
procedure MouseMinYMaxY(MinY,MaxY:Integer);
procedure SetVideoPage(Page:Integer);
procedure GetVideoPage(var Page:Integer);

implementation
uses Dos;


var   R: Registers;
      Mi:Pointer;

function MouseInit(var nb:Integer):Boolean;
begin
       if MousePresent then
           begin
              R.AX:=0;
              Intr($33,R);
               if R.AX=0 then
                 begin
                  nb:=0;
                  MouseInit:=False
                end
              else
                begin
                  nb:=R.AX;
                  MouseInit:=True
                end
              end
           else
              begin
                 nb:=0;
                 MouseInit:=False
               end
end;


procedure MouseShow;
begin
   R.AX:=1;
   Intr($33,R)
end;

procedure MouseHide;
begin
   R.AX:=2;
   Intr($33,R)
end;

procedure MouseRead(var X,Y,bMask:integer);
begin
   R.AX:=3;
   Intr($33,R);
   X:=R.CX;
   Y:=R.DX;
   bMask:=R.BX
end;

procedure MouseSetPos(x,y:Word);
begin
   R.AX:=4;
   R.CX:=X;
   R.DX:=Y;
   Intr($33,R)
end;


function MouseGetb(bMask:Word;var Count,LastX,LastY:Word):Word;
begin
   R.AX:=5;
   R.BX:=bMask;Intr($33,R);
   Count:=R.BX;
   LastX:=R.CX;
   LastY:=R.DX;
   MouseGetb:=R.AX
end;

procedure MouseMinXMaxX(MinX,MaxX:Integer);
begin
   R.AX:=7;
   R.CX:=MinX;
   R.DX:=MaxX;
   Intr($33,R)
end;

procedure MouseMinYMaxY(MinY,MaxY:Integer);
begin
   R.AX:=8;
   R.CX:=MinY;
   R.DX:=MaxY;
   Intr($33,R)
end;

procedure SetVideoPage(Page:Integer);
begin
   R.AX:=$1D;
   R.BX:=Page;
   Intr($33,R)
end;

procedure GetVideoPage(var Page:Integer);
begin
   R.AX:=$1E;
   Intr($33,R);
   Page:=R.BX;
end;

procedure MouseKeyPreset(var Key,Sost,X,Y:integer);
begin
   R.AX:=$6;
   R.BX:=Key;
   Intr($33,R);
   Key:=R.AX;
   Sost:=R.BX;
   X:=R.CX;
   Y:=R.DX;
end;


begin
   GetIntVec($33,Mi);
   if Mi=nil then
    MousePresent:=False
    else
    if Byte(Mi^)=$CE then
       MousePresent:=False
       else
       MousePresent:=True
end.

