unit Chars14;
{ 뢠 ⠡ ᨬ ࠧ஬ 8*14 ᥫ
  ॡ 䠩 writchar.obj, fonts.fnt
}
interface
uses Graph;

const
  CharWidth=8;
  CharHeight=14;

function TextHeight(text:string):word; {}
function TextWidth(text:string):word;
procedure OutText(text:string); {뢮 ப   }
procedure OutTextXY(x,y:integer; text:string); {뢮 ப  㪠 }

implementation
{$F-}
{$L WRITCHAR.OBJ}

var
  Font: array[0..$ff,1..14] of byte;

procedure WritChar(x,y:word; col:byte; text,font:pointer; num:byte);
            external;

procedure OutTextXY(x,y:integer; text:string);
var
  v: ViewPortType;
  tset: TextSettingsType;
  col,num,beg: byte;
  xrep,yrep: integer;
begin
  if Length(text)<>0 then begin
    GetViewSettings(v);
    GetTextSettings(tset);
    case tset.Horiz of
      LeftText:   xrep:=x;
      CenterText: xrep:=x-((Length(text)*CharWidth) shr 1);
      RightText:  xrep:=x-Length(text)*CharWidth;
    end;
    case tset.Vert of
      TopText:    yrep:=y;
      CenterText: yrep:=y-(CharHeight shr 1);
      BottomText: yrep:=y-CharHeight
    end;
    if (yrep<0) or (yrep+CharHeight>v.y2-v.y1) then Exit;
    if xrep>=0 then beg:=0 else beg:=((-xrep) div CharWidth)-1;
    if beg>=Length(text) then Exit;
    if xrep+Length(text)*CharWidth>v.x2-v.x1 then begin
      num:=((v.x2-v.x1-xrep) div CharWidth)-beg
    end else num:=Length(text)-beg;
    WritChar(xrep+beg*CharWidth+v.x1,yrep+v.y1,GetColor,@text[beg+1],
               @Font,num);
  end;
  MoveTo(x+Length(text)*CharWidth,y);
end;

procedure OutText(text:string);
begin
  OutTextXY(GetX,GetY,text)
end;

function TextHeight(text:string):word;
begin
  TextHeight:=CharHeight
end;

function TextWidth(text:string):word;
begin
  TextWidth:=Length(text)*CharWidth
end;
{$F+}
var
  f: ^file;

begin
  New(f); Assign(f^,'FONTS.FNT'); Reset(f^,1);
  BlockRead(f^,Font,Sizeof(font)); Close(f^); Dispose(f)
end.